backend/fet/urls.py
from django.urls import path

from .views import (
    RoundOrderSuccessView,
    RoundOrderView,
    RoundProviderRecapView,
    RoundSelectionView,
    RoundUserRecapView,
)

urlpatterns = [
    path("", RoundSelectionView.as_view(), name="index"),
    path(
        "round/<int:pk>/order/", RoundOrderView.as_view(), name="round-order"
    ),
    path(
        "round/<int:pk>/success/",
        RoundOrderSuccessView.as_view(),
        name="round-order-success",
    ),
    path(
        "round/<int:pk>/recap-provider/",
        RoundProviderRecapView.as_view(),
        name="round-recap-provider",
    ),
    path(
        "round/<int:pk>/recap-user/",
        RoundUserRecapView.as_view(),
        name="round-recap-user",
    ),
]

backend/yakafet/urls.py
from django.urls import include, path
from django_utils.urls import default, drf

urlpatterns = (
    default.urlpatterns()
    + drf.urlpatterns(with_auth=True)
    + [
        path("", include("fet.urls")),
    ]
)

backend/fet/models.py
from django.contrib.auth import get_user_model
from django.contrib.auth.models import Group
from django.db import models

User = get_user_model()


class Event(models.Model):
    name = models.CharField(max_length=200)

    groups = models.ManyToManyField(Group)

    def __str__(self):
        return self.name


class Provider(models.Model):
    name = models.CharField(max_length=200, unique=True)

    def __str__(self):
        return self.name


class Round(models.Model):
    event = models.ForeignKey(Event, on_delete=models.CASCADE)

    date = models.DateField()

    accept_orders = models.BooleanField(default=True)

    providers = models.ManyToManyField(Provider)

    class Meta:
        ordering = ("-date",)

    def __str__(self):
        return f"{self.event} - {self.date}"


class Fet(models.Model):
    provider = models.ForeignKey(Provider, on_delete=models.CASCADE)

    name = models.CharField(max_length=200)
    enabled = models.BooleanField(default=True)
    description = models.TextField(blank=True, default="")

    image = models.FileField(
        upload_to="fet/fets/",
        blank=True,
        null=True,
    )
    image_url = models.URLField(blank=True, default="")

    class Meta:
        ordering = ("provider",)

    def __str__(self):
        return f"{self.provider} - {self.name}"


class Order(models.Model):
    user = models.ForeignKey(User, on_delete=models.CASCADE)

    round = models.ForeignKey(
        to="fet.Round", related_name="orders", on_delete=models.CASCADE
    )

    fet = models.ForeignKey(Fet, on_delete=models.CASCADE)

    notes = models.TextField(blank=True, default="")

    class Meta:
        unique_together = ("user", "round")

    def __str__(self):
        return f"{self.round} - {self.user}"

backend/fet/forms.py
from django import forms

from .models import Order


class FetSelectionForm(forms.ModelForm):
    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.fields["user"].required = False
        self.fields["round"].required = False

    class Meta:
        fields = ("fet", "user", "notes", "round")
        model = Order

backend/fet/views.py
from django.contrib.auth.mixins import LoginRequiredMixin, UserPassesTestMixin
from django.db.models import Count
from django.http import HttpResponseRedirect
from django.shortcuts import get_object_or_404
from django.urls import reverse
from django.utils import timezone
from django.views.generic import DetailView, FormView, ListView
from django.views.generic.detail import SingleObjectMixin

from .forms import FetSelectionForm
from .models import Fet, Order, Round


class RoundMixin:
    def get_queryset(self):
        qs = Round.objects.filter(date=timezone.now().date())
        if not self.request.user.is_staff:
            qs = qs.filter(
                event__groups__in=self.request.user.groups.all(),
                accept_orders=True,
            )
        return qs


class RoundSelectionView(RoundMixin, LoginRequiredMixin, ListView):
    template_name = "fet/index.html"

    def get(self, request, *args, **kwargs):
        self.object_list = self.get_queryset()
        if self.object_list.count() == 1 and not self.request.user.is_staff:
            return HttpResponseRedirect(
                reverse(
                    "round-order", kwargs={"pk": self.object_list.first().pk}
                )
            )
        return super().get(request, *args, **kwargs)


class RoundOrderView(
    RoundMixin, LoginRequiredMixin, FormView, SingleObjectMixin
):
    template_name = "fet/select.html"
    form_class = FetSelectionForm

    def get_success_url(self):
        return reverse("round-order-success", kwargs={"pk": self.object.pk})

    def order_already_exists(self):
        return Order.objects.filter(
            round=self.object, user=self.request.user
        ).exists()

    def get(self, request, *args, **kwargs):
        self.object = self.get_object()
        if self.order_already_exists():
            return HttpResponseRedirect(self.get_success_url())
        return super().get(request, *args, **kwargs)

    def post(self, request, *args, **kwargs):
        self.object = self.get_object()
        if self.order_already_exists():
            return HttpResponseRedirect(self.get_success_url())
        return super().post(request, *args, **kwargs)

    def get_fets(self):
        return Fet.objects.filter(
            provider__round=self.object,
            enabled=True,
        ).order_by("provider")

    def get_form(self, *args, **kwargs):
        form = super().get_form(*args, **kwargs)
        form.fields["fet"].queryset = self.get_fets()
        return form

    def form_valid(self, form):
        form.instance.user = self.request.user
        form.instance.round = self.object
        form.save()
        return super().form_valid(form)

    def get_context_data(self, *args, **kwargs):
        context = super().get_context_data(*args, **kwargs)
        context["fets"] = self.get_fets()
        return context


class RoundOrderSuccessView(LoginRequiredMixin, DetailView):
    template_name = "fet/success.html"

    def get_object(self, queryset=None):
        round = super().get_object(queryset=Round.objects.all())
        return get_object_or_404(Order, round=round, user=self.request.user)


class RoundUserRecapView(LoginRequiredMixin, UserPassesTestMixin, DetailView):
    template_name = "fet/recap-user.html"

    queryset = Round.objects.all()

    def test_func(self):
        return self.request.user.is_staff

    def get_context_data(self, *args, **kwargs):
        context = super().get_context_data(**kwargs)

        orders = (
            Order.objects.filter(
                round=self.object,
            )
            .annotate(order__count=Count("fet"))
            .order_by("user__last_name", "user__first_name")
            .values(
                "user__username",
                "user__first_name",
                "user__last_name",
                "fet__provider__name",
                "fet__name",
            )
        )
        context["orders"] = orders

        return context


class RoundProviderRecapView(
    LoginRequiredMixin, UserPassesTestMixin, DetailView
):
    template_name = "fet/recap-provider.html"

    queryset = Round.objects.all()

    def test_func(self):
        return self.request.user.is_staff

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)

        orders = (
            Order.objects.filter(
                round=self.object,
            )
            .order_by("fet__provider__name")
            .values(
                "fet__provider__name",
                "fet__name",
                "fet__description",
            )
            .annotate(order_count=Count("fet__name"))
        )

        context["orders"] = orders

        return context

backend/fet/templates/fet/base.html
{% load static %}
<html>
  <head>
    <meta charset="utf-8">
    <link rel="icon" type="image/gif" href="{% static 'fet/hotdog.gif' %}">

    <!-- UIkit CSS -->
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/uikit@3.11.1/dist/css/uikit.min.css" />
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- UIkit JS -->
    <script src="https://cdn.jsdelivr.net/npm/uikit@3.11.1/dist/js/uikit.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/uikit@3.11.1/dist/js/uikit-icons.min.js"></script>
    <title>Yakafet</title>
  </head>

  <body class="uk-background-muted">
    <nav class="uk-navbar-container uk-margin" uk-navbar style="background-color: #EFB758;">
      <div class="uk-navbar-center">

        <div class="uk-navbar-center-left"><div>
          <ul class="uk-navbar-nav">
            <li class="uk-active"><a href="{% url 'index' %}">Accueil</a></li>
          </ul>
        </div></div>
        <a class="uk-navbar-item uk-logo" href="{% url 'index' %}"><img width="54px" src="https://prologin.org/static/img/logo_cube.png" alt="Logo Prologin"></a>
        <div class="uk-navbar-center-right"><div>
          <ul class="uk-navbar-nav">
            {% if user.is_staff %}
            <li class="uk-active"><a href="{% url 'admin:index' %}">Administration</a></li>
            {% endif %}
          </ul>
        </div></div>

      </div>
    </nav>
    <main>
      <div class="uk-container uk-container-large uk-margin-medium-top">
        {% block content %}
        {% endblock %}
      </div>
    </main>
  </body>
</html>

backend/fet/templates/fet/index.html
{% extends 'fet/base.html' %}

{% block content %}

<h1 class="page-title">
  Sélectionnez votre événement
</h1>

{% if object_list %}
<table class="uk-table uk-table-divider">
  <thead>
    <tr>
      <th>Date</th>
      <th>Événement</th>
      {% if request.user.is_staff %}
      <th>Accepte les commandes</th>
      <th>Récapitulatif</th>
      {% endif %}
    </tr>
  </thead>
  <tbody>
    {% for object in object_list %}
    <tr>
      <td>{{ object.date }}</td>
      <td><a href="{% url 'round-order' object.pk %}">{{ object.event }}</a></td>
      {% if request.user.is_staff %}
      <td>{% if object.accept_orders %}Oui{% else %}Non{% endif %}</td>
      <td>
        <a class="uk-button uk-button-default" href="{% url 'round-recap-provider' object.pk %}">Fournisseur</a>
        <a class="uk-button uk-button-default" href="{% url 'round-recap-user' object.pk %}">Client</a>
      </td>
      {% endif %}
    </tr>
    {% endfor %}
  </tbody>
</table>
{% else %}
<p>Il n'est pas actuellement possible de choisir un repas.</p>
{% endif %}

{% regroup fets by provider as provider_list %}

{% for provider, provider_fets in provider_list %}
<br><br>
<h2 class="uk-heading-small">{{ provider }}</h2>
<div class="uk-child-width-1-4@m uk-text-center uk-grid-match" uk-grid>
  {% for fet in provider_fets %}
  <div>
    <div class="uk-card uk-card-default uk-card-body">
      {% if fet.image %}
      <div class="uk-card-media-top">
        <img src="{{ fet.image.url }}" alt="{{ fet.name }}" style="max-height:200px;">
      </div>
      {% elif fet.image_url %}
      <div class="uk-card-media-top">
        <img src="{{ fet.image_url }}" alt="{{ fet.name }}" style="max-height:200px;">
      </div>
      {% endif %}
      <h3 class="uk-card-title">{{ fet.name }}</h3>
      {% if fet.description %}
      {{ fet.description | linebreaks }}
      {% else %}
      <em>Description non fournie</em>
      {% endif %}
      <div class="uk-card-footer">
        <form action="" method="POST">
          {% csrf_token %}
          <input type="hidden" name="fet" value="{{ fet.id }}">
          <button class="uk-button uk-button-primary uk-button-large">Choisir</button>
        </form>
      </div>
    </div>
  </div>
  {% endfor %}
</div>
{% endfor %}
<br><br><br><br>


{% endblock %}

backend/fet/templates/fet/recap-provider.html
{% extends 'fet/base.html' %}

{% block content %}

<h1 class="page-title">Récapitulatif Commandes ({{ request.user.event }})</h1>
<br>
{% regroup orders by fet__provider__name as grouped_orders %}

{% for provider_name, provider_orders in grouped_orders %}

<h1>{{ provider_name }}</h1>


<table class="uk-table uk-table-divider">
    <thead>
        <tr>
            <th>Plat</th>
            <th>Quantité</th>
        </tr>
    </thead>
    <tbody>
        {% for order in provider_orders %}
            <tr>
                <td>
                    {{ order.fet__name }} <br>
                    {{ order.fet__description | linebreaks }}
                </td>
                <td>{{ order.order_count }}</td>
            </tr>
        {% endfor %}
    </tbody>
</table>

{% endfor %}

{% endblock %}

backend/fet/templates/fet/recap-user.html
{% extends 'fet/base.html' %}

{% block content %}

<h1 class="page-title">Récapitulatif Commandes ({{ object.event }})</h1>
<br>
<table class="uk-table uk-table-divider">
    <thead>
        <tr>
            <th>Login</th>
            <th>Prénom</th>
            <th>Nom</th>
            <th>Fournisseur</th>
            <th>Commande</th>
        </tr>
    </thead>
    <tbody>
    {% for order in orders %}
        <tr>
            <td>{{ order.user__username  }}</td>
            <td>{{ order.user__first_name }}</td>
            <td>{{ order.user__last_name }}</td>
            <td>{{ order.fet__provider__name }}</td>
            <td>{{ order.fet__name }}</td>
        </tr>
    {% endfor %}
</table>

{% endblock %}

backend/fet/templates/fet/select.html
{% extends 'fet/base.html' %}

{% block content %}

<h1 class="uk-heading-medium">
    Sélectionner votre repas
</h1>

<p class="uk-text-lead">pour le {{ object.date }}</p>

<br>
<br>

<p>{{ form.errors }}</p>

    {% regroup fets by provider as provider_list %}

    {% for provider, provider_fets in provider_list %}
    <br><br>
    <h2 class="uk-heading-small">{{ provider }}</h2>
    <div class="uk-child-width-1-4@m uk-text-center uk-grid-match" uk-grid>
    {% for fet in provider_fets %}
        <div>
            <div class="uk-card uk-card-default uk-card-body">
                    {% if fet.image %}
                      <div class="uk-card-media-top">
                        <img src="{{ fet.image.url }}" alt="{{ fet.name }}" style="max-height:200px;">
                      </div>
                    {% elif fet.image_url %}
                      <div class="uk-card-media-top">
                        <img src="{{ fet.image_url }}" alt="{{ fet.name }}" style="max-height:200px;">
                      </div>
                    {% endif %}
                    <h3 class="uk-card-title">{{ fet.name }}</h3>
                    {% if fet.description %}
                        {{ fet.description | linebreaks }}
                    {% else %}
                        <em>Description non fournie</em>
                    {% endif %}
                <div class="uk-card-footer">
                    <form action="" method="POST">
                        {% csrf_token %}
                        <input type="hidden" name="fet" value="{{ fet.id }}">
                        <button class="uk-button uk-button-primary uk-button-large">Choisir</button>
                    </form>
                </div>
            </div>
        </div>
    {% endfor %}
    </div>
    {% endfor %}
    <br><br><br><br>


{% endblock %}

backend/fet/templates/fet/success.html
{% extends 'fet/base.html' %}
{% load static %}

{% block content %}
<br><br><br><br>
<div class="uk-text-center">
    <img class="ok-sign" src="{% static 'fet/hotdog.gif' %}" alt="signe ok">
    <h2 class="order-status">Votre commande est en cours de préparation</h2>
    <p><b><em>{{ object.fet }}</em></b></p>
    <br><br><br>
    <p>Merci d'utiliser YakaFet</p>
</div>
{% endblock %}